package net.sergeych.parsec

open class ParsecException(val code: String, val text: String, reason: Throwable? = null) :
    Exception("($code): $text", reason)

class ParsecInnerException(text: String): ParsecException("inner_error", text)
class ParsecRemoteException(code: String,text: String) : ParsecException(code, text)
class ParsecAuthenticationException(text: String) : ParsecException("parsec_authentication_error", text)