@file:OptIn(ExperimentalSerializationApi::class)

package net.sergeych.parsec

import kotlinx.serialization.ExperimentalSerializationApi
import net.sergeych.boss_serialization.BossDecoder
import net.sergeych.boss_serialization_mp.BossEncoder
import net.sergeych.boss_serialization_mp.BossStruct
import net.sergeych.boss_serialization_mp.bossStructOf

interface ParsecConnection {
    suspend fun call(command: String, params: BossStruct = BossStruct.EMPTY): BossStruct

    suspend fun call(command: String,vararg args: Pair<String,Any?>): BossStruct =
        call(command, BossStruct(mutableMapOf(*args)))
}

inline suspend fun <reified T> ParsecConnection.exec(command: String): T = BossDecoder.decodeFrom(call(command))

inline suspend fun <reified T: Any,reified R> ParsecConnection.exec(command: String, args: T): R {
    return BossDecoder.decodeFrom(call(command, BossEncoder.encodeToStruct(args)))
}

inline suspend fun <reified R> ParsecConnection.exec(command: String, vararg args: Pair<String,Any?>): R {
    return BossDecoder.decodeFrom(call(command, bossStructOf(*args)))
}

