package net.sergeych.ugdx

import kotlinx.serialization.Serializable
import net.sergeych.ugdx.client.PasswordKeys
import net.sergeych.unikrypto.HashAlgorithm
import kotlin.random.Random

@Serializable
data class DerivationParams(
    val rounds: Int,
    val hashAlgorithm: HashAlgorithm,
    val salt: ByteArray
) {
    suspend fun deriveFrom(password: String): PasswordKeys = PasswordKeys.deriveFrom(password, this)

    companion object {
        fun random(rounds: Int = 100000,hashAlgorithm: HashAlgorithm=HashAlgorithm.SHA3_256) =
            DerivationParams(rounds, hashAlgorithm, Random.Default.nextBytes(32))
    }
}
