package net.sergeych.ugdx.shared

import kotlinx.coroutines.Deferred
import net.sergeych.parsec.ParsecConnection
import net.sergeych.parsec.exec

/**
 * Deprecated("Use ApiCommand for new commands")
 */
enum class UgdxCommand {

    CHECK_NAME_AVAILABLE,
    CHECK_INVITE_CODE,
    AUTH_REGISTER,

    REQUEST_SIGN_IN, REQUEST_SING_IN_OBJECT, PERFORM_SIGN_IN,
    SIGN_OUT, CHECK_STATUS,

    GET_CURRENCIES, GET_ETH_SIGNATURE_MESSAGE, ADD_ETH_ADDRESS, GET_ETH_ADDRESSES,

    DELETE_TEST_USER,

    TEST_IMPORT;

    suspend inline fun <reified A: Any,reified R> call(connection: ParsecConnection,args: A): R =
        connection.exec(name, args)

    suspend inline fun <reified A: Any,reified R> call(connection: Deferred<ParsecConnection>,args: A): R =
        connection.await().exec(name, args)

    suspend inline fun <reified R> call(connection: ParsecConnection,vararg args: Pair<String,Any>): R =
        connection.exec(name, *args)

    suspend inline fun <reified R> call(connection: Deferred<ParsecConnection>,vararg args: Pair<String,Any>): R =
        connection.await().exec(name, *args)
}

