@file:UseSerializers(BigDecimalSerializer::class)
@file:OptIn(ExperimentalSerializationApi::class)

package net.sergeych.ugdx.shared.api

import net.sergeych.ugdx.GuestAPI
import net.sergeych.ugdx.shared.BigDecimalSerializer
import kotlinx.serialization.ExperimentalSerializationApi
import kotlinx.serialization.UseSerializers
import net.sergeych.boss_serialization.BossDecoder
import net.sergeych.boss_serialization_mp.BossEncoder
import net.sergeych.boss_serialization_mp.BossStruct
import kotlin.reflect.KType
import kotlin.reflect.typeOf

class ApiCommand<T : Any,R : Any>(val name: String,val argsClass: KType,val resultClass: KType) {

    suspend operator fun invoke(args: T): R {
        val result = net.sergeych.ugdx.GuestAPI.connection.await().call(name, BossEncoder.encodeToStruct(argsClass,args))
        return BossDecoder.decodeFrom<R>(resultClass, result)
    }

    suspend operator fun invoke(): R {
        val result = net.sergeych.ugdx.GuestAPI.connection.await().call(name, BossStruct.EMPTY)
        return BossDecoder.decodeFrom<R>(resultClass, result)
    }

    companion object {
        inline operator fun <reified T : Any, reified R : Any>invoke(name: String): ApiCommand<T, R> =
            ApiCommand<T,R>(name, typeOf<T>(), typeOf<R>())
    }

}

