package net.sergeych.ugdx.shared.api.admin

import net.sergeych.ugdx.shared.Currency
import net.sergeych.ugdx.shared.EmptyResult
import net.sergeych.ugdx.shared.api.ApiCommand
import kotlinx.datetime.Instant
import kotlinx.serialization.Serializable

@Serializable
data class ApiCurrencyRecord(
    val id: Long,
    val code: String,
    val name: String,
    val symbol: String,
    val isApproved: Boolean,
    val createdByUserId: Long?,
    val realm: Currency.Realm,
    val platformId: String,
    val canExport: Boolean,
    val canCreateAccount: Boolean,
    val roundingScale: Int?,
    val description: String?,
    val connected: Boolean,
    val createdAt: Instant
)

@Suppress("unused")
@Serializable
data class CurrencyRecordArgs(
    val code: String,
    val name: String,
    val symbol: String,
    val isApproved: Boolean,
    val createdByUserId: Long?,
    val realm: Currency.Realm,
    val platformId: String,
    val canExport: Boolean,
    val canCreateAccount: Boolean,
    val roundingScale: Int?,
    val description: String?,
)

val cmdAdminCurrencies = ApiCommand<EmptyResult,List<ApiCurrencyRecord>>("Admin.Currency.allRecords")
