@file:UseSerializers(BigDecimalSerializer::class)
@file:Suppress("unused")

package net.sergeych.ugdx.shared.api

import net.sergeych.ugdx.shared.*
import kotlinx.serialization.Serializable
import kotlinx.serialization.UseSerializers

@Serializable
class SubmitOrderArgs(val signedOrder: ByteArray)
val cmdSubmitOrder = ApiCommand<SubmitOrderArgs,OrderRecord>("Orders.submit")

@Serializable
class OrderIdArgs(val orderId: Long)
val cmdGetOrder = ApiCommand<OrderIdArgs,OrderRecord>("Orders.get")

@Serializable
class OrderListArgs(val earlierThanId: String?=null,val maxSize: Int=50)

@Serializable
class OrderListResult(val orders: List<OrderRecord>, val hasMore: Boolean)
val cmdListOrders = ApiCommand<OrderListArgs,OrderListResult>("Orders.list")


