@file:UseSerializers(BigDecimalSerializer::class)
package net.sergeych.ugdx.shared.api.unit

import net.sergeych.ugdx.shared.BigDecimalSerializer
import com.ionspin.kotlin.bignum.decimal.BigDecimal
import kotlinx.coroutines.flow.Flow
import kotlinx.datetime.Clock
import kotlinx.datetime.Instant
import kotlinx.serialization.Serializable
import kotlinx.serialization.UseSerializers
import net.sergeych.kryptools.randomId
import net.sergeych.mptools.Now
import net.sergeych.mptools.bd
import net.sergeych.unikrypto.HashAlgorithm

class UnitApplication private constructor (
    val title: String,
    val text: String,
    val amount: BigDecimal,
    val id: String = randomId(17),
    val createdAt: Instant = Now()
) {

    enum class Status {
        Draft, Submitted, Feedback, Approved, Executed, Rejected;

        /**
         * If true, status could be changed without applicatn action and refreshing it could
         * be of use.
         */
        val isDynamic by lazy { this == Approved }
    }

    enum class Author {
        Applicant, Agent, System
    }

    @Serializable
    data class Message(
        val from: Author,
        val text: String,
        val changes: List<Change>,
        val oldStatus: Status? = null,
        val newStatus: Status? = null,
        val createdAt: Instant = Now(),
        val uid: String = randomId(7)
    )

    @Serializable
    data class Change(val fieldName: String,val oldValue: String,val newValue: String)

    @Serializable
    data class SharedFile(
        val uid: String,
        val fileName: String,
        val description: String,
        val hashAlgorithm: HashAlgorithm,
        val digest: ByteArray
    )

    /**
     * Send new message _on behalf of the applicant_.
     */
    suspend fun postMessage(text: String): UnitApplication {
        TODO()
    }

    suspend fun delete() {
        TODO()
    }

    suspend fun refresh(): UnitApplication? {
        TODO()
    }

    suspend fun attachFile(name: String,description: String,data: ByteArray) {

    }

    companion object {
        suspend fun byId(): UnitApplication? {
            TODO()
        }

        suspend fun getOrCreateDraft(): UnitApplication {
            // TODO: Get the draft
            // no draft exists:

            TODO()
        }

        suspend fun all(): Flow<UnitApplication> {
            TODO()
        }
    }

}
