@file:Suppress("unused")

package net.sergeych.ugdx.shared.api

import net.sergeych.ugdx.shared.EmptyResult
import kotlinx.datetime.Instant
import kotlinx.serialization.Serializable


@Serializable
class UserSetDataArgs(val dataKey: String,val encryptedData: ByteArray)

@Serializable
class UserGetDataArgs(val dataKey: String)

@Serializable
class UserDataResult(val encryptedData: ByteArray,val createdAt: Instant)

val cmdUserSetData = ApiCommand<UserSetDataArgs, EmptyResult>("User.setData")
val cmdUserGetData = ApiCommand<UserGetDataArgs, UserDataResult>("User.getData")
val cmdUserDropData = ApiCommand<UserGetDataArgs, EmptyResult>("User.dropData")
