@file:OptIn(DelicateCoroutinesApi::class)

package net.sergeych.parsec

import kotlinx.coroutines.DelicateCoroutinesApi
import kotlinx.coroutines.GlobalScope
import kotlinx.coroutines.launch
import net.sergeych.mp_logger.Log
import net.sergeych.mp_logger.LogTag
import net.sergeych.mp_logger.info

private var consoleConnected = false

@Suppress("unused")
fun Log.connectBrowserConsole(overrideDefaultLevel: Log.Level? = Log.Level.DEBUG) {
    if (!consoleConnected) {
        consoleConnected = true
        GlobalScope.launch {
            logFlow.collect { le ->
                when (le.level) {
                    Log.Level.DEBUG -> console.log(le.toString())
                    Log.Level.INFO -> console.info(le.toString())
                    Log.Level.WARNING -> console.warn(le.toString())
                    Log.Level.ERROR -> console.error(le.toString())
                    Log.Level.HIDDEN -> {}
                }
            }
        }
        overrideDefaultLevel?.let { defaultLevel = it }
        LogTag("BRLOG").info { "connected browser console"}
    }
}